diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/page.c tin-2.6.5/src/page.c
--- tin-2.6.4/src/page.c	2024-12-11 16:39:37.000000000 +0100
+++ tin-2.6.5/src/page.c	2025-11-13 02:21:32.552178773 +0100
@@ -2940,11 +2796,11 @@ build_url_list(
 		 */
 		forever {
 			/* any matches left? */
-			if (match_regex_ex(ptr, (REGEX_SIZE) strlen(ptr), 0, 0, &url_regex) >= 0) {
+			if (MATCH_REGEX(url_regex, ptr, strlen(ptr))) {
 				offsets = regex_get_ovector_pointer(&url_regex);
-			} else if (match_regex_ex(ptr, (REGEX_SIZE) strlen(ptr), 0, 0, &mail_regex) >= 0) {
+			} else if (MATCH_REGEX(mail_regex, ptr, strlen(ptr))) {
 				offsets = regex_get_ovector_pointer(&mail_regex);
-			} else if (match_regex_ex(ptr, (REGEX_SIZE) strlen(ptr), 0, 0, &news_regex) >= 0) {
+			} else if (MATCH_REGEX(news_regex, ptr, strlen(ptr))) {
 				offsets = regex_get_ovector_pointer(&news_regex);
 			} else
 				break;
@@ -2996,7 +2852,10 @@ show_article_info_page(
 
 
 #define MIME_FLAG(what) (ptr->mime_hints.flags & what)
-/* TODO: strings to lang.c and _() ? */
+/*
+ * TODO: - strings to lang.c and _() ?
+ *       - examine headers too? (e.g. look for unencoded 8bit chars)
+ */
 void
 log_article_info(
 	t_openartinfo *artinfo)
@@ -3006,6 +2865,8 @@ log_article_info(
 	FILE *fp;
 	t_part *ptr;
 #ifdef DEBUG
+	const char *filename_star;
+	const char *filename;
 	const char *name;
 #endif /* DEBUG */
 
@@ -3037,6 +2898,8 @@ log_article_info(
 			fprintf(fp, " / %s: %s", "Unsupported", ptr->mime_hints.subtype);
 		else
 			fprintf(fp, " / %s", ptr->mime_hints.subtype);
+		if (ptr->format)
+			fprintf(fp, "%s", " ; Format=Flowed");
 		fprintf(fp, "\n\t\tUsed:\t\t%s / %s", content_types[ptr->type], ptr->subtype);
 
 		charset = get_param(ptr->params, "charset");
@@ -3073,7 +2936,18 @@ log_article_info(
 			fprintf(fp, "%s", content_encodings[ptr->encoding]);
 		fprintf(fp, "\n\t\tUsed:\t\t%s", content_encodings[ptr->encoding]);
 
+		if (artinfo->tex2iso)
+			fprintf(fp, "\n\n\t\t%s\n", _(txt_tex));
+
 #ifdef DEBUG
+		if ((filename_star = get_param(ptr->params, "filename*")) != NULL) {
+			fprintf(fp, "\n\tFilename*:\n");
+			fprintf(fp, "\t\t%s", filename_star);
+		}
+		if ((filename = get_param(ptr->params, "filename")) != NULL) {
+			fprintf(fp, "\n\tFilename:\n");
+			fprintf(fp, "\t\t%s", filename);
+		}
 		if ((name = get_param(ptr->params, "name")) != NULL) {
 			fprintf(fp, "\n\tName:\n");
 			fprintf(fp, "\t\t%s", name);
@@ -3090,6 +2964,13 @@ log_article_info(
 			fprintf(fp, "\n\tContent Disposition:\n");
 			fprintf(fp, "\t\t%s", ptr->disposition == DISP_INLINE ? content_disposition[DISP_INLINE] : content_disposition[DISP_ATTACHMENT]);
 		}
+		fprintf(fp, "\n");
+		if (filename_star && *filename_star && filename && *filename && strcmp(filename_star, filename))
+			fprintf(fp, "\n!!\tFilename*: %s != Filename: %s", filename_star, filename);
+		if (filename_star && *filename_star && name && *name && strcmp(filename_star, name))
+			fprintf(fp, "\n!!\tFilename*: %s != Name: %s", filename_star, name);
+		if (filename && *filename && name && *name && strcmp(filename, name))
+			fprintf(fp, "\n!!\tFilename: %s != Name: %s", filename, name);
 #endif /* DEBUG */
 		fprintf(fp, "\n");
 	}
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/parsdate.y tin-2.6.5/src/parsdate.y
--- tin-2.6.4/src/parsdate.y	2024-12-21 03:46:48.000000000 +0100
+++ tin-2.6.5/src/parsdate.y	2025-07-21 15:32:40.291972160 +0200
@@ -4,7 +4,7 @@
  *  Module    : parsedate.y
  *  Author    : S. Bellovin, R. $alz, J. Berets, P. Eggert
  *  Created   : 1990-08-01
- *  Updated   : 2024-12-21
+ *  Updated   : 2024-12-31
  *  Notes     : This grammar has 6 shift/reduce conflicts.
  *              Originally written by Steven M. Bellovin <smb@research.att.com>
  *              while at the University of North Carolina at Chapel Hill.
@@ -121,12 +121,11 @@ date_error(const char UNUSED(*s))
     enum _MERIDIAN	Meridian;
 }
 
-%token	tDAY tDAYZONE tMERIDIAN tMONTH tMONTH_UNIT tSEC_UNIT tSNUMBER
-%token	tUNUMBER tZONE tDST
+%token	<Number>	tDAY tDAYZONE tMERIDIAN tMONTH tMONTH_UNIT tSEC_UNIT tSNUMBER
+%token	<Number>	tUNUMBER tZONE tDST
 
-%type	<Number>	tDAYZONE tMONTH tMONTH_UNIT tSEC_UNIT
-%type	<Number>	tSNUMBER tUNUMBER tZONE numzone zone
-%type	<Meridian>	tMERIDIAN o_merid
+%type	<Number>	numzone zone
+%type	<Meridian>	o_merid
 
 %%
 
@@ -538,8 +537,8 @@ Convert(
     if (Year < 0)
 	Year = -Year;
     if (Year < 70)
-        Year += 2000;
-    if (Year < 100)
+    Year += 2000;
+    if (Year < 200)
 	Year += 1900;
     if (Year < EPOCH)
 	Year += 100;
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/pgp.c tin-2.6.5/src/pgp.c
--- tin-2.6.4/src/pgp.c	2024-11-25 20:40:37.000000000 +0100
+++ tin-2.6.5/src/pgp.c	2025-12-06 00:27:07.857763869 +0100
@@ -3,10 +3,10 @@
  *  Module    : pgp.c
  *  Author    : Steven J. Madsen
  *  Created   : 1995-05-12
- *  Updated   : 2024-11-23
+ *  Updated   : 2025-12-06
  *  Notes     : PGP support
  *
- * Copyright (c) 1995-2025 Steven J. Madsen <steve@erinet.com>
+ * Copyright (c) 1995-2026 Steven J. Madsen <steve@erinet.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -85,6 +85,7 @@
 #		define PGPNAME		PATH_GPG
 #		define PGPDIR		".gnupg"
 #		define PGP_PUBRING	"pubring.gpg"
+#		define PGP_PUBRING_KBX	"pubring.kbx"	/* since GnuPG 2.1 */
 #		if 0 /* gpg 1.4.11 doesn't like this */
 #			define CHECK_SIGN	"%s %s --no-batch --decrypt <%s %s"
 #		else
@@ -110,9 +111,6 @@ PGPNAME, pgpopts, pt, mailto, mailfrom,
 #	endif /* HAVE_GPG */
 
 /* RFC 4880 6.2 */
-#	define PGP_SIG_TAG "-----BEGIN PGP SIGNED MESSAGE-----\n"
-#	define PGP_KEY_TAG "-----BEGIN PGP PUBLIC KEY BLOCK-----\n"
-
 #	define HEADERS	"tin-%ld.h"
 #	ifdef HAVE_LONG_FILE_NAMES
 #		define PLAINTEXT	"tin-%ld.pt"
@@ -264,7 +262,7 @@ do_pgp(
 	/*
 	 * <mailfrom> is valid only when signing and a local address exists
 	 */
-	if (CURR_GROUP.attribute->from != NULL && *CURR_GROUP.attribute->from)
+	if (CURR_GROUP.attribute->from != NULL && *CURR_GROUP.attribute->from && strchr(*CURR_GROUP.attribute->from, '@'))
 		strip_name(*CURR_GROUP.attribute->from, mailfrom);
 
 	switch (what) {
@@ -305,7 +303,7 @@ pgp_append_public_key(
 	char cmd[LEN], buf[LEN];
 	char keyfile[PATH_LEN], tmp[PATH_LEN];
 
-	if (CURR_GROUP.attribute->from != NULL && *CURR_GROUP.attribute->from && **CURR_GROUP.attribute->from)
+	if (CURR_GROUP.attribute->from != NULL && *CURR_GROUP.attribute->from && strchr(*CURR_GROUP.attribute->from, '@'))
 		strip_name(*CURR_GROUP.attribute->from, buf);
 	else /* FIXME: avoid hardcoded length */
 		snprintf(buf, sizeof(buf), "%.*s@%.765s", LOGIN_NAME_MAX - 1, userid, BlankIfNull(get_host_name()));
@@ -342,14 +340,23 @@ pgp_available(
 	FILE *fp;
 	char keyring[PATH_LEN];
 
+#ifdef HAVE_GPG
+	/* GnuPG >= 2.1 may use PGP_PUBRING_KBX */
+	joinpath(keyring, sizeof(keyring), pgp_data, PGP_PUBRING_KBX);
+	if ((fp = fopen(keyring, "r")) != NULL) {
+		fclose(fp);
+		return TRUE;
+	}
+#endif /* HAVE_GPG */
+
 	joinpath(keyring, sizeof(keyring), pgp_data, PGP_PUBRING);
-	if ((fp = fopen(keyring, "r")) == NULL) {
-		wait_message(2, _(txt_pgp_not_avail), keyring);
-		return FALSE;
+	if ((fp = fopen(keyring, "r")) != NULL) {
+		fclose(fp);
+		return TRUE;
 	}
 
-	fclose(fp);
-	return TRUE;
+	wait_message(2, _(txt_pgp_not_avail), keyring);
+	return FALSE;
 }
 
 
@@ -452,14 +459,15 @@ pgp_check_article(
 	int n;
 	size_t len;
 	t_bool pgp_signed = FALSE;
-	t_bool pgp_key = FALSE;
+	int pgp_key = 0;
 
 	if (!pgp_available())
 		return FALSE;
 
 	joinpath(artfile, sizeof(artfile), homedir, TIN_ARTICLE_NAME);
 #	ifdef APPEND_PID
-	snprintf(artfile + strlen(artfile), sizeof(artfile) - strlen(artfile), ".%ld", (long) process_id);
+	n = strlen(artfile);
+	snprintf(artfile + n, sizeof(artfile) - n, ".%ld", (long) process_id);
 #	endif /* APPEND_PID */
 	if ((art = fopen(artfile, "w")) == NULL) {
 		info_message(_(txt_cannot_open), artfile);
@@ -475,15 +483,15 @@ pgp_check_article(
 		if (fgets(buf, sizeof(buf), artinfo->raw) != NULL) {
 			if (!pgp_signed && !strcmp(buf, PGP_SIG_TAG))
 				pgp_signed = TRUE;
-			if (!pgp_key && !strcmp(buf, PGP_KEY_TAG))
-				pgp_key = TRUE;
+			if (!strcmp(buf, PGP_PUBLIC_KEY_TAG))
+				++pgp_key;
 			fputs(buf, art);
 		} else
 			break;
 	}
 	fclose(art);
 
-	if (!(pgp_signed || pgp_key)) {
+	if (!pgp_signed && !pgp_key) {
 		info_message(_(txt_pgp_nothing));
 		return FALSE;
 	}
@@ -515,10 +523,10 @@ pgp_check_article(
 	InitWin();
 #	endif /* !USE_CURSES */
 	if (pgp_key) {
-		if (prompt_yn(_(txt_pgp_add), FALSE) == 1) {
+		if (prompt_yn(P_(txt_pgp_add_sp[0], txt_pgp_add_sp[1], pgp_key), FALSE) == 1) {
 			Raw(FALSE);
 			n = snprintf(NULL, 0, ADD_KEY, PGPNAME, pgpopts, artfile);
-			len = (size_t) (n << 1) + 1; /* double size for quoting */
+			len = ((size_t) n << 1) + 1; /* double size for quoting */
 			cmd = my_malloc(len);
 			sh_format(cmd, len, ADD_KEY, PGPNAME, pgpopts, artfile);
 			invoke_cmd(cmd);
